#include <stdio.h>

int sx,sy;

#define QMAX 1000000

int qmin,qmax;
int qx[QMAX],qy[QMAX],qd[QMAX];

int maz[128][128];
int arr[128][128];

int EMPTY(void)
{ return(qmin==qmax);
}

void PUSH(int x,int y,int d)
{
  if(arr[x][y] && arr[x][y]<=d)
{
  /*   printf("NPSH %d %d %d x %d\n",x,y,d,arr[x][y]); */
 return;
}
  /* printf("PUSH %d %d %d\n",x,y,d); */
  arr[x][y]=d;
  qx[qmax]=x;
  qy[qmax]=y;
  qd[qmax]=d;
  qmax++;
}

void POP(int *x,int *y,int *d)
{
  *x=qx[qmin];
  *y=qy[qmin];
  *d=qd[qmin];
  qmin++;
}

int solved=0;
int x2,y2,d;

int ATT(int x,int y)
{
  if(solved||x<0||y<0||x>sx+1||y>sy+1)
{
  /*printf("ATT %d %d FALSE\n",x,y);
   */return 0;}
  if(x==x2 && y==y2) {solved=d+1;}
  /*printf("ATT %d %d M=%d\n",x,y,maz[x][y]);*/
  if(x>sx||y>sy||x==0||y==0) return 1;
  return !maz[x][y];
}

int main(void)
{ int x,y,I=1,II,i;
  int x1,y1; 
  char ch; 
  char lin[128],*l;

  freopen("game.in","rt",stdin);

  while(1)
    {  
      scanf("%d %d\n",&sx,&sy);
      if(sx==0) break;
      printf("Board #%d:\n",I++);
      for(y=1;y<=sy;y++)
	{
	  gets(lin);l=lin;
	  for(x=1;x<=sx;x++)
	    {
	      ch=*l;l++;
	      if(ch=='X') maz[x][y]=1;
	      else maz[x][y]=0;
	    }
	  /*	  for(x=1;x<=sx;x++) printf("%c",maz[x][y]+'0');
		  printf("\n"); */
      	}
      II=1;
      while(1)
	{
	  qmin=qmax=0;
	  memset(arr,0,sizeof(arr));
	  solved=0;

	  scanf("%d %d %d %d",&x1,&y1,&x2,&y2);
	  if(x1==0) break;
	  /*	  	  printf("(%d,%d)->(%d,%d)\n",x1,y1,x2,y2);*/
	  PUSH(x1,y1,0);
	  
	  while(!EMPTY())
	    {
	      POP(&x,&y,&d);
	      /*	      printf(":ST=%d %d %d\n",x,y,d);*/
	      for(i=1;ATT(x-i,y);i++) PUSH(x-i,y,d+1);
	      for(i=1;ATT(x+i,y);i++) PUSH(x+i,y,d+1);
	      for(i=1;ATT(x,y-i);i++) PUSH(x,y-i,d+1);
	      for(i=1;ATT(x,y+i);i++) PUSH(x,y+i,d+1);
	      if(solved) break;
	    }
	  printf("Pair %d: ",II++);
	  if(solved) printf("%d segments.\n",solved);
	  else printf("impossible.\n");
	}
      printf("\n");
    }

  return 0;
}
